#property indicator_chart_window 
#property indicator_buffers 1
#property strict
//---- plot Line 
#property indicator_label1  "Line" 
#property indicator_type1   DRAW_LINE 
#property indicator_color1  clrDarkBlue 
#property indicator_style1  STYLE_SOLID 
#property indicator_width1  1
#include <stdlib.mqh>
//--- indicator buffers 
double         LineBuffer[];
//+------------------------------------------------------------------+
//| Indicies to Display Object Property Arrays                       |
//+------------------------------------------------------------------+
enum objectIndicies
{
   CALLCOUNTER = 0,
   INDICOUNT,
   WINDBARS,
   WINDVIS,
   BARSFUNC,
   IBARSFUNC,
   RATESTOTAL,
   PREVCALCULATED,
   TIMECALC,
   OPENCALC,  
   HIGHCALC,
   LOWCALC,
   CLOSECALC,
   TICKVOLUME,
   VOLUMECALC,
   SPREADCALC,
   OnCalcEnumEnd
};
enum controlIndicies
{
   ONESTEP   = 0,
   STEPTOEND,
   RUNCONTINUOUS,
   ControlEnumEnd
};
//+------------------------------------------------------------------+
//| display object control values and storage arrays                 |
//+------------------------------------------------------------------+ 
const ENUM_OBJECT ary_dispObjType[] = {    OBJ_LABEL,    OBJ_LABEL,    OBJ_LABEL,    OBJ_LABEL,    OBJ_LABEL,    OBJ_LABEL,     OBJ_LABEL,   OBJ_LABEL,         OBJ_LABEL,       OBJ_LABEL,       OBJ_LABEL,      OBJ_LABEL,        OBJ_LABEL,       OBJ_LABEL,     OBJ_LABEL,    OBJ_LABEL};
const string     ary_dispObjNames[] = { "Call_Count",  "IndiCount", "WindowBars", "WindVisible", "BarsFunc",   "iBarsFunc",  "RatesTotal", "Prev_Calc",       "Time_Calc",     "Open_Calc",     "High_Calc",     "Low_Calc",     "Close_Calc", "Tick_Vol_Calc", "Volume_Calc","Spread_Calc"};
const int         ary_dispObjXPos[] = {           20,           20,           20,           20,           20,           20,            20,          20,                20,              20,              20,             20,               20,              20,            20,           20};
const int         ary_dispObjYPos[] = {           20,           40,           60,           80,          100,          120,           140,         160,               180,             200,             220,            240,              260,             280,           300,          320};
const color      ary_dispObjColor[] = {    clrYellow,    clrYellow,    clrYellow,    clrYellow,    clrYellow,    clrYellow,     clrYellow,   clrYellow,         clrYellow,       clrYellow,       clrYellow,      clrYellow,        clrYellow,       clrYellow,     clrYellow,    clrYellow};
string              ary_As_Series[] = {           "",           "",           "",           "",           "",           "",            "",          "",                "",              "",              "",             "",               "",              "",            "",           ""};
string            ary_dispObjText[] = {           "",           "",           "",           "",           "",           "",            "",          "",                "",              "",              "",             "",               "",              "",            "",           ""};
struct OnCalcValues                   {uint callCount;int indiCount; int winBars;   int winVis; int barsFunc;int iBarsFunc;int ratesTotal;int prevCalc; datetime timeCalc; double openCalc; double highCalc; double lowCalc; double closeCalc; long tickVolume;   long volume;   int spread;};
OnCalcValues ary_OnCalcVals[3];   // store values passed into OnCalculate
//+------------------------------------------------------------------+
//| Program Constants                                                |
//+------------------------------------------------------------------+
const int DISPALYWINDOWZERO = 0;
const int THECURRENTCHART   = 0;
const int ARRAYNEW          = 0;
const int ARRAYOLD1         = 1;
const int ARRAYONFIRST      = ArraySize(ary_OnCalcVals)-1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() 
{ 
   //--- indicator buffers mapping 
   SetIndexBuffer(0,LineBuffer,INDICATOR_DATA); 
   //--- 
   ary_OnCalcVals[ARRAYNEW].callCount = 0;
   return(INIT_SUCCEEDED); 
}
void OnDeinit(const int reason)
{
   for (int i = 0; i < OnCalcEnumEnd; i++)
   {
      ObjectDelete(THECURRENTCHART,ary_dispObjNames[i]);
   }
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, 
                const int prev_calculated, 
                const datetime& time[], 
                const double& open[], 
                const double& high[], 
                const double& low[], 
                const double& close[], 
                const long& tick_volume[], 
                const long& volume[], 
                const int& spread[]) 
{ 
    
    //+------------------------------------------------------------------+
    //| Save Previous On Calculate values into the Array                 |
    //+------------------------------------------------------------------+
    CopyNewToOld(ary_OnCalcVals[ARRAYNEW].callCount);
    ary_OnCalcVals[ARRAYNEW].callCount ++;   // Track number of calls to OnCalculate
    //+------------------------------------------------------------------+
    //| Find out if the arrays are series or not                         |
    //+------------------------------------------------------------------+
    if ( ary_OnCalcVals[ARRAYNEW].callCount == 1 )   // detect if each array is AS_SERIES or not
    {
      ary_As_Series[TIMECALC]    = ArrayGetAsSeries(time)?"As_Series":"Not_Series";
      ary_As_Series[OPENCALC]    = ArrayGetAsSeries(open)?"As_Series":"Not_Series";
      ary_As_Series[HIGHCALC]    = ArrayGetAsSeries(high)?"As_Series":"Not_Series";
      ary_As_Series[LOWCALC]     = ArrayGetAsSeries(low)?"As_Series":"Not_Series";
      ary_As_Series[CLOSECALC]   = ArrayGetAsSeries(close)?"As_Series":"Not_Series";
      ary_As_Series[TICKVOLUME]  = ArrayGetAsSeries(tick_volume)?"As_Series":"Not_Series";
      ary_As_Series[VOLUMECALC]  = ArrayGetAsSeries(volume)?"As_Series":"Not_Series";
      ary_As_Series[SPREADCALC]  = ArrayGetAsSeries(spread)?"As_Series":"Not_Series";
    }
    //+------------------------------------------------------------------+
    //| Load the new On Calculae values into the array                   |
    //+------------------------------------------------------------------+
    ary_OnCalcVals[ARRAYNEW].ratesTotal = rates_total;
    ary_OnCalcVals[ARRAYNEW].prevCalc   = prev_calculated;
    // if ( ThereIsANewBar() )  // These should only be updated with a new bar - Not sure what volume[] and spread[] do.
    // {
       ary_OnCalcVals[ARRAYNEW].timeCalc   = time[0];
       ary_OnCalcVals[ARRAYNEW].openCalc   = open[0];
       ary_OnCalcVals[ARRAYNEW].highCalc   = high[0];
       ary_OnCalcVals[ARRAYNEW].lowCalc    = low[0];
       ary_OnCalcVals[ARRAYNEW].closeCalc  = close[0];
       ary_OnCalcVals[ARRAYNEW].tickVolume = tick_volume[0];
       // ary_OnCalcVals[ARRAYNEW].spread    = volume[0];  // Gives 'Out of Range' error and the indicator stops
       ary_OnCalcVals[ARRAYNEW].volume     = Volume[0];
       // ary_OnCalcVals[ARRAYNEW].spread    = spread[0];  // Gives 'Out of Range' error and the indicator stops
       ary_OnCalcVals[ARRAYNEW].spread     = 0;  //  Spread(0) seems to be an MQL5 function only.
       //+------------------------------------------------------------------+
       //| Load Load other bars functions for comparison                    |
       //+------------------------------------------------------------------+
       ary_OnCalcVals[ARRAYNEW].indiCount  = IndicatorCounted();
       ary_OnCalcVals[ARRAYNEW].barsFunc   = Bars(Symbol(), Period());
       ary_OnCalcVals[ARRAYNEW].iBarsFunc  = iBars(Symbol(),Period());
    // }
       ary_OnCalcVals[ARRAYNEW].winBars    = WindowBarsPerChart();
       ary_OnCalcVals[ARRAYNEW].winVis     = WindowFirstVisibleBar();
    //+------------------------------------------------------------------+
    //| Display the Old and New Values                                   |
    //+------------------------------------------------------------------+
    DisplayOnCalcValues();
    /*
   //--- Get the number of bars available for the current symbol and chart period 
   int bars=Bars(Symbol(),0); 
   Print("Bars = ",bars,", rates_total = ",rates_total,",  prev_calculated = ",prev_calculated); 
   Print("time[0] = ",time[0]," time[rates_total-1] = ",time[rates_total-1]); 
   //--- return value of prev_calculated for next call 
   */
   return(rates_total); 
}
//+------------------------------------------------------------------+
//| Create check for a new bar also ensure it loads on the first call|
//+------------------------------------------------------------------+
bool ThereIsANewBar(void)
{
   int newBar = false;
   static datetime lastBarTime=0;
   if ( (Time[0] > lastBarTime) || (1 == ary_OnCalcVals[ARRAYNEW].callCount) )
   {
      lastBarTime = Time[0];
      newBar = true;
   }
   return (newBar);
}
//+------------------------------------------------------------------+
//| Create text for each label to display the values                 |
//+------------------------------------------------------------------+
void CopyNewToOld(int CallCount)
{
   if (CallCount == 1 )
   {
      MoveNewTo(ARRAYONFIRST);
   }
   MoveNewTo(ARRAYOLD1);
}
void MoveNewTo(int aryIndx)
{
      ary_OnCalcVals[aryIndx].callCount  = ary_OnCalcVals[ARRAYNEW].callCount;
      ary_OnCalcVals[aryIndx].indiCount  = ary_OnCalcVals[ARRAYNEW].indiCount;
      ary_OnCalcVals[aryIndx].winBars    = ary_OnCalcVals[ARRAYNEW].winBars;
      ary_OnCalcVals[aryIndx].winVis     = ary_OnCalcVals[ARRAYNEW].winVis;
      ary_OnCalcVals[aryIndx].barsFunc   = ary_OnCalcVals[ARRAYNEW].barsFunc;
      ary_OnCalcVals[aryIndx].iBarsFunc  = ary_OnCalcVals[ARRAYNEW].iBarsFunc;
      ary_OnCalcVals[aryIndx].ratesTotal = ary_OnCalcVals[ARRAYNEW].ratesTotal;
      ary_OnCalcVals[aryIndx].prevCalc   = ary_OnCalcVals[ARRAYNEW].prevCalc;
      ary_OnCalcVals[aryIndx].timeCalc   = ary_OnCalcVals[ARRAYNEW].timeCalc;
      ary_OnCalcVals[aryIndx].openCalc   = ary_OnCalcVals[ARRAYNEW].openCalc;
      ary_OnCalcVals[aryIndx].highCalc   = ary_OnCalcVals[ARRAYNEW].highCalc;
      ary_OnCalcVals[aryIndx].lowCalc    = ary_OnCalcVals[ARRAYNEW].lowCalc;
      ary_OnCalcVals[aryIndx].closeCalc  = ary_OnCalcVals[ARRAYNEW].closeCalc;
      ary_OnCalcVals[aryIndx].tickVolume = ary_OnCalcVals[ARRAYNEW].tickVolume;
      ary_OnCalcVals[aryIndx].volume     = ary_OnCalcVals[ARRAYNEW].volume;
      ary_OnCalcVals[aryIndx].spread     = ary_OnCalcVals[ARRAYNEW].spread;
}
void DisplayOnCalcValues(void)
{
   for (int i = 0; i < OnCalcEnumEnd; i++)
   {
      SetLabelObjectText(i);
   }
}
void SetLabelObjectText(const int ObjectID)
{
   switch(ObjectID)          //  Switch on the display objects:  Include not-lable objects to creater debug msg if erroneously called.
   {
      case CALLCOUNTER:
         ary_dispObjText[ObjectID] = "OnCalc Calls: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].callCount)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].callCount)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].callCount);
         MakeALabel(ObjectID);
         break;
      case INDICOUNT:
         ary_dispObjText[ObjectID] = "Indicator Counted: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].indiCount)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].indiCount)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].indiCount);
         MakeALabel(ObjectID);
         break;
      case WINDBARS:
         ary_dispObjText[ObjectID] = "Window Bars: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].winBars)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].winBars)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].winBars);
         MakeALabel(ObjectID);
         break;
      case WINDVIS:
         ary_dispObjText[ObjectID] = "Visible Bars: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].winVis)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].winVis)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].winVis);
         MakeALabel(ObjectID);
         break;
      case IBARSFUNC:
         ary_dispObjText[ObjectID] = " i Bars Func: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].iBarsFunc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].iBarsFunc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].iBarsFunc);
         MakeALabel(ObjectID);
         break;
      case BARSFUNC:
         ary_dispObjText[ObjectID] = "Bars Func: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].barsFunc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].barsFunc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].barsFunc);
         MakeALabel(ObjectID);
         break;
      case RATESTOTAL:
         ary_dispObjText[ObjectID] = "Rates Total: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].ratesTotal)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].ratesTotal)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].ratesTotal);
         MakeALabel(ObjectID);
         break;
      case PREVCALCULATED:
         ary_dispObjText[ObjectID] = "Previous Calculated: "+IntegerToString(ary_OnCalcVals[ARRAYNEW].prevCalc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].prevCalc)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].prevCalc);
         MakeALabel(ObjectID);
         break;
      case TIMECALC:    
         ary_dispObjText[ObjectID] = "time[0] "+ary_As_Series[ObjectID]+": "+TimeToString(ary_OnCalcVals[ARRAYNEW].timeCalc)+" / "+TimeToString(ary_OnCalcVals[ARRAYOLD1].timeCalc)+" / "+TimeToString(ary_OnCalcVals[ARRAYONFIRST].timeCalc);
         MakeALabel(ObjectID);
         break;
      case OPENCALC:   
         ary_dispObjText[ObjectID] = "open[0] "+ary_As_Series[ObjectID]+": "+DoubleToString(ary_OnCalcVals[ARRAYNEW].openCalc,_Digits)+" / "+DoubleToString(ary_OnCalcVals[ARRAYOLD1].openCalc,_Digits)+" / "+DoubleToStr(ary_OnCalcVals[ARRAYONFIRST].openCalc,_Digits);
         MakeALabel(ObjectID);
         break;
      case HIGHCALC:
         ary_dispObjText[ObjectID] = "high[0] "+ary_As_Series[ObjectID]+": "+DoubleToString(ary_OnCalcVals[ARRAYNEW].highCalc,_Digits)+" / "+DoubleToString(ary_OnCalcVals[ARRAYOLD1].highCalc,_Digits)+" / "+DoubleToStr(ary_OnCalcVals[ARRAYONFIRST].highCalc,_Digits);
         MakeALabel(ObjectID);
         break;
      case LOWCALC:
         ary_dispObjText[ObjectID] = "low[0] "+ary_As_Series[ObjectID]+": "+DoubleToString(ary_OnCalcVals[ARRAYNEW].lowCalc,_Digits)+" / "+DoubleToString(ary_OnCalcVals[ARRAYOLD1].lowCalc,_Digits)+" / "+DoubleToStr(ary_OnCalcVals[ARRAYONFIRST].lowCalc,_Digits);
         MakeALabel(ObjectID);
         break;
      case CLOSECALC:
         ary_dispObjText[ObjectID] = "close[0] "+ary_As_Series[ObjectID]+": "+DoubleToString(ary_OnCalcVals[ARRAYNEW].closeCalc,_Digits)+" / "+DoubleToString(ary_OnCalcVals[ARRAYOLD1].closeCalc,_Digits)+" / "+DoubleToStr(ary_OnCalcVals[ARRAYONFIRST].closeCalc,_Digits);
         MakeALabel(ObjectID);
         break;
      case TICKVOLUME:
         ary_dispObjText[ObjectID] = "Tick Volume "+ary_As_Series[ObjectID]+": "+IntegerToString(ary_OnCalcVals[ARRAYNEW].tickVolume)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].tickVolume)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].tickVolume);
         MakeALabel(ObjectID);
         break;
      case VOLUMECALC:
         ary_dispObjText[ObjectID] = "Volume "+ary_As_Series[ObjectID]+": "+IntegerToString(ary_OnCalcVals[ARRAYNEW].volume)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].volume)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].volume);
         MakeALabel(ObjectID);
         break;
      case SPREADCALC:
         ary_dispObjText[ObjectID] = "spread "+ary_As_Series[ObjectID]+": "+IntegerToString(ary_OnCalcVals[ARRAYNEW].spread)+" / "+IntegerToString(ary_OnCalcVals[ARRAYOLD1].spread)+" / "+IntegerToString(ary_OnCalcVals[ARRAYONFIRST].spread);
         MakeALabel(ObjectID);
         break;
      default:
         break;
   }
}
//+------------------------------------------------------------------+
//| Display Label objects                                            |
//+------------------------------------------------------------------+
void MakeALabel(int displayOjectIndex)   // Display Text
{
   int windowIndex=ObjectFind(ary_dispObjNames[displayOjectIndex]); // Find which window the object is in (does it exist?)
   if(windowIndex<0) // No window found with the object in it - Create the object
   {
      ObjectCreate(THECURRENTCHART,ary_dispObjNames[displayOjectIndex], OBJ_LABEL, DISPALYWINDOWZERO, 0, 0);    // Create on window 0
      ObjectSetInteger(THECURRENTCHART,ary_dispObjNames[displayOjectIndex],OBJPROP_ANCHOR,CORNER_RIGHT_UPPER);   //  Attach the text to the corner of the lable.
      ObjectSetInteger(THECURRENTCHART,ary_dispObjNames[displayOjectIndex],OBJPROP_HIDDEN,true);                 // Hidden, must press 'all' to see in object list
      ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_CORNER, CORNER_RIGHT_LOWER);                          // attach the lable to the corner of the chart
   }
   ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_XDISTANCE, ary_dispObjXPos[displayOjectIndex]);             // justify at xPos from the right
   ObjectSet(ary_dispObjNames[displayOjectIndex], OBJPROP_YDISTANCE, ary_dispObjYPos[displayOjectIndex]);             // place at yPos from the top 
   ObjectSetText(ary_dispObjNames[displayOjectIndex],ary_dispObjText[displayOjectIndex],11,"Tahoma",ary_dispObjColor[displayOjectIndex]);  // display the text
}